diff -r f68f5aca440e src/lib-storage/index/imapc/imapc-list.c
--- a/src/lib-storage/index/imapc/imapc-list.c	Sun Aug 19 12:53:06 2012 +0300
+++ b/src/lib-storage/index/imapc/imapc-list.c	Sun Aug 19 18:21:58 2012 +0300
@@ -345,6 +345,7 @@
 {
 	struct imapc_command *cmd;
 	struct imapc_simple_context ctx;
+	struct mailbox_node *node;
 	const char *pattern;
 
 	i_assert(list->sep != '\0');
@@ -370,7 +371,14 @@
 		   marked with inbox=yes, show the INBOX even if
 		   imapc_list_prefix doesn't match it */
 		bool created;
-		(void)mailbox_tree_get(list->mailboxes, "INBOX", &created);
+		node = mailbox_tree_get(list->mailboxes, "INBOX", &created);
+		if (*list->storage->set->imapc_list_prefix != '\0') {
+			/* this listing didn't include the INBOX itself, but
+			   might have included its children. make sure there
+			   aren't any extra flags in it (especially
+			   \NonExistent) */
+			node->flags &= MAILBOX_CHILDREN;
+		}
 	}
 
 	imapc_simple_run(&ctx);
